Subject: Re: Problem authenticating using WPA with bcm43xx-softmac

From: Larry Finger <[email-masked]>
Date: Wed, 07 Jun 2006 12:07:27 -0500

Johannes Berg wrote:
> On Wed, 2006-06-07 at 09:01 -0700, Sam Leffler wrote:
> 
>> Beware of the order of IE's in the management frames; some AP's are
>> touchy about this.
> 
> Uh oh. I have no idea where the ieee80211 layer sticks that one,
> probably at the end.

I moved the WPA IE from the end forward without any effect. I have dumped that IE and find the 
following:

SoftMAC: Added WPA_IE of 24 bytes to association request
Contents of WPA_IE: 0xdd 0x16 0x00 0x50 0xf2 0x01 0x01 0x00 0x00 0x50
                     0xf2 0x02 0x01 0x00 0x00 0x50 0xf2 0x02 0x01 0x00
                     0x00 0x50 0xf2 0x02

I think I got the right thing, but I'm having trouble interpreting it. The dump was made by 
modifying the part of ieee80211softmac_assoc_req in ieee80211softmac_io.c where the WPA IE is added:

         /* Add WPA IE */
         if (mac->wpa.IElen && mac->wpa.IE) {
                 int i;
                 memcpy(data, mac->wpa.IE, mac->wpa.IElen);
                 data += mac->wpa.IElen;
                 printk(KERN_INFO PFX "Added WPA_IE of %d bytes to association request\n"
                         "Contents of WPA_IE: ", mac->wpa.IElen);
                 for (i=0; i<mac->wpa.IElen; i++)
                         printk("0x%02x ",mac->wpa.IE[i]);
                 printk("\n");
         }

Larry